echo off
rem *** Unprotect for Zany Golf
rem *** By Michael B. Williams
rem ***    CIS:  73667,3264
rem ***    uucp: research!golem!mikew
echo This batch file unprotects the version of Zany Golf dated 10-17-88.
echo If your version has a different date, this patch may not work.
if not exist zany.com if not exist tzany.com goto direrror
echo This patch also requires that DEBUG.COM be in the current directory or
echo in a directory specified in your PATH environment variable.
echo Press a key to proceed or CTRL-BREAK to terminate this batch file.
pause > nul
echo *** WORKING ***
:zany
if not exist zany.com goto tzany
if not exist zany.fix goto nozanyfix
rem *** Unprotect ZANY.COM
copy zany.com zany!.com > nul
debug zany!.com < zany.fix > nul
echo The EGA version of Zany Golf has been unprotected as ZANY!.COM.
:tzany
if not exist tzany.com goto ok
if not exist tzany.fix goto notzanyfix
rem *** Unprotect TZANY.COM
copy tzany.com tzany!.com > nul
debug tzany!.com < tzany.fix > nul
echo The Tandy version of Zany Golf has been unprotected as TZANY!.COM.
goto ok
:nozanyfix
echo The file ZANY.FIX cannot be found in the current directory.
goto advice
:notzanyfix
echo The file TZANY.FIX cannot be found in the current directory.
goto advice
:direrror
echo Neither the EGA version of Zany Golf (ZANY.COM) nor the Tandy version
echo of Zany Golf (TZANY.COM) can be found in the current directory.
:advice
echo Please change to the proper directory and type ZANY-FIX again.
goto end
:ok
echo *** NOTE ***
echo Your original program files have been left untouched.  You should use
echo the unprotected versions that have been added to the current directory:
echo     ZANY!      runs the unprotected EGA version
echo     TZANY!     runs the unprotected Tandy version
echo Enjoy your Zany Golf. -- M.B.W. 7/19/89
:end
